/*
 * Created by victoria on 2021-05-13.
 */

#include "context.h"
#include "crypto/crypto.h"

using namespace Signal;

Context::Context() : cryptoProvider{ Signal::Crypto::createProvider() } {
    signal_context_create(&ctx, nullptr);
    signal_context_set_crypto_provider(ctx, &cryptoProvider);
}

Context::~Context() {
    signal_context_destroy(ctx);
}

std::unique_ptr<Crypto::ECKeyPair> Context::generateCurveKeyPair() {
    auto result = std::unique_ptr<Crypto::ECKeyPair>();
    // TODO

    return result;
}

signal_context *Context::temporaryGetContextUnsafeForRawAccessThatNeedsToBeWrapped() {
    return ctx;
}
