/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Store {

    class SignedPreKeyStore {
    public:
        int loadSignedPreKey(signal_buffer **record, uint32_t signed_pre_key_id);
        int storeSignedPreKey(uint32_t signed_pre_key_id, uint8_t *record, size_t record_len);
        int containsSignedPreKey(uint32_t signed_pre_key_id);
        int removeSignedPreKey(uint32_t signed_pre_key_id);

        void fillCallbacks(signal_protocol_signed_pre_key_store &store);
    };

} // namespace Signal::Store
