/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Crypto::Aes {

    int encrypt(signal_buffer **output, int cipher, const uint8_t *key, size_t key_len, const uint8_t *iv,
                size_t iv_len, const uint8_t *plaintext, size_t plaintext_len, void *user_data);

    int decrypt(signal_buffer **output, int cipher, const uint8_t *key, size_t key_len, const uint8_t *iv,
                size_t iv_len, const uint8_t *ciphertext, size_t ciphertext_len, void *user_data);

} // namespace Signal::Crypto::Aes
