/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Crypto::HmacSha256 {

    int init(void **hmac_context, const uint8_t *key, size_t key_len, void *);
    int update(void *hmac_context, const uint8_t *data, size_t data_len, void *);
    int final(void *hmac_context, signal_buffer **output, void *);
    void cleanup(void *hmac_context, void *);

} // namespace Signal::Crypto::HmacSha256
